// py.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


/////////////////////
//
// - PyModule
//
/////////////////////

PyModule::~PyModule()
{
			
		std::vector <PyMethodDef>::iterator i =  methods.begin();
		for(;i!=methods.end();++i){
				if((*i).ml_name) delete [] (*i).ml_name;
					
		}

			
}
void PyModule::RegisterMethod(const char *name, PyCallback fn)
{	
			// :((
			int len = strlen(name);
			char *p = new char[strlen(name)+1];
			strcpy(p,name);
			p[len]=0;
			PyMethodDef def = 
					{ 
						p,	          //name
						fn,           //callback
						METH_VARARGS, //callback method
						NULL		  // ;**
					};
			methods.push_back(def);
}

/////////////////////
//
// - PyVM
//
/////////////////////


bool PyVM::Init(const char *n)
{
			End();
			Py_SetProgramName(const_cast<char*>(n));
			Py_Initialize();
			if(Py_IsInitialized())
				m_init = true;
			else
				m_init = false;			
			return ok();
}

bool PyVM::ExecString(const char *s)
{
		assert(ok());
		if( -1 == PyRun_SimpleString(const_cast<char*> (s) ))
			return false;
		return true;
}

//crash with pyrun_simplefile()! :_(
//http://www.webdocs.org/docs/python/official/faq/008.html#8.7
bool PyVM::ExecFile(char *n)
{
			assert(ok());		
			FILE *f = fopen(n,"r");
			if(!f) return false;
			fseek(f,0,SEEK_END);
			int len =  ftell(f);
			char *p= new char[len+1];
			if(!p){
				fclose(f);
				return false;
			}
			rewind(f);
			fread(p,len,1,f);
			p[len]=0;	
			
			int ret =  ExecString(p);
			fclose(f);
				
			delete [] p;
			if(-1 == ret)			
					return false;
			
			return true;
}
bool PyVM::RegiterMod(PyModule &mod)
{
			assert(ok());		
			std::list<PyModule*>::iterator i = ModList.begin();
			for(;i!=ModList.end();++i){
				if( (*i)->Name() == mod.Name()){
					return false; 
				}
			}
			ModList.push_back(&mod);
			Py_InitModule(const_cast<char*>(mod.Name().c_str()),mod.Methods());
			return true;

}


		



	



